package demo;

import java.awt.*;
import javax.swing.*;

public class MyStack extends JPanel implements StackInterface {
	
	static final int SIZE = 5;
//	int idx = 0;
	int idx = SIZE - 1;

	char[] data = new char[SIZE];
	boolean empty = true;
	boolean full = false;
	
	JTextField status;
	JTextField[] stackContent = new JTextField[SIZE];
	JTextField[] stackPointer = new JTextField[SIZE];
	JTextField[] message = new JTextField[SIZE];
	
	public MyStack() {
		this("MyStack");
	}
	public MyStack(String name) {
		setBackground(Color.CYAN);
		setLayout(new BorderLayout());
		//pane.setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		Box content = new Box(BoxLayout.Y_AXIS);
		Box pointer = new Box(BoxLayout.Y_AXIS);
		Box messages = new Box(BoxLayout.Y_AXIS);
		for (int i = 0; i < SIZE; i++) {
			stackContent[i] = new JTextField(5);
			stackContent[i].setEditable(false);
			stackContent[i].setBackground(Color.yellow);
			content.add(stackContent[i]);
			stackPointer[i] = new JTextField(5);
			pointer.add(stackPointer[i]);
			message[i] = new JTextField(5);
			message[i].setBackground(Color.green);
			messages.add(message[i]);
		}
		setPointer(idx);
		
		add(new JLabel(name, SwingConstants.CENTER), BorderLayout.PAGE_START);
		JPanel p = new JPanel(new FlowLayout());
		p.add(content);
		p.add(pointer);
		p.add(messages);
		add(p, BorderLayout.CENTER);
		
		status = new JTextField(40);
		add(status, BorderLayout.PAGE_END);
		setVisible(true);
	}
	
	public void setPointer(int pos) {
		for (int i = 0; i < SIZE; i++) {
			stackPointer[i].setText("");
		}
		stackPointer[pos].setText("<--");
	}
	
	public void push(char c) {
		data[idx] = c;
		stackContent[idx].setText("" + c);
		idx--;
		setPointer(idx);
	}
	
	public char pop() {
		char c = 0;
		idx++;
		setPointer(idx);
		stackContent[idx].setText("");
		c = data[idx];
		data[idx] = '\u0000';
		return c;
	}
	
	public boolean stableTest() {
		boolean stable = true;
		if (data[idx] == '\u0000') { // OK
			stable = true;
		} else {
			message[idx].setBackground(Color.RED);			
			stable = false;
		}
		return stable;
	}
}