package demo;

import java.awt.*;

import javax.swing.*;

public class PreferredStack extends MyStack {

	public PreferredStack() {
		super("PreferedStack");
		setBackground(Color.green);
		
	}

	public synchronized void push(char c) {
		full = !(idx > 0);
		if (full) {
			status.setBackground(Color.yellow);
			status.setText("Stack full ... wait");
			try {
				wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		assert (idx > 0);
		data[idx] = c;
		stackContent[idx].setText("" + c);
		idx--;
		setPointer(idx);
		
		status.setBackground(Color.GREEN);
		status.setText("PUSH --> " + c);
		
		empty = false;
		notify();
	}

	public synchronized char pop() {
		char c = 0;
		empty = !(idx < SIZE - 2);
		if (empty) {
			status.setBackground(Color.pink);
			status.setText("stack empty ... wait for content");
			try {
				wait();
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		assert (idx < SIZE - 2);
		idx++;
		setPointer(idx);
		stackContent[idx].setText("");
		c = data[idx];
		data[idx] = '\u0000';
		
		status.setBackground(Color.GREEN);
		status.setText("POP <-- " + c);

		full = false;
		notify();
		return c;
	}

	public synchronized boolean stableTest() {
		boolean stable = true;
		if (data[idx] == '\u0000') { // OK
			stable = true;
		} else {
			message[idx].setBackground(Color.RED);			stable = false;
		}
		return stable;
	}
	
	public synchronized void setPointer(int pos) {
		for (int i = 0; i < SIZE; i++) {
			stackPointer[i].setText("");
		}
		stackPointer[pos].setText("<--");
	}

}