package demo;

import java.awt.GridLayout;

import java.awt.*;
import javax.swing.*;

public class StackTester {

	public static final int DURATION = 1000;

	public static void main(String[] args) {

		JFrame f = new JFrame("Unprotected Shared Data");
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Container cp = f.getContentPane();
		cp.setLayout(new FlowLayout());
		
		MyStack m = new PreferredStack();

		cp.add(m);
		f.pack();
		f.setVisible(true);

		StackPusher pusher = new StackPusher(m);
		StackPopper popper = new StackPopper(m);
		Thread t1 = new Thread(pusher, "Pusher");
		Thread t2 = new Thread(popper, "Poppor");

		t1.start();
		t2.start();
		new Thread(new StackChecker(m)).start();
//		new Thread(new StackPopper(m), "Popper-2").start();
	}
	
	public static void pause(int sec) {
		try {
			Thread.sleep(sec * 1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
}

class StackPusher implements Runnable {
	MyStack my;

	public StackPusher(MyStack ms) {
		my = ms;
	}

	public void run() {
		while (true) {
			int i = (int) (Math.random() * 26);
			char c = (char) ('a' + i);
			my.push(c);
			try {
				int time = (int) (Math.random() * StackTester.DURATION);
				Thread.sleep(time);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}

class StackPopper implements Runnable {
	MyStack my;

	public StackPopper(MyStack ms) {
		my = ms;
	}

	public void run() {
		while (true) {
			char c = my.pop();
			try {
				int time = (int) (Math.random() * StackTester.DURATION);
				Thread.sleep(time);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}

class StackChecker implements Runnable {
	MyStack my;

	public StackChecker(MyStack ms) {
		my = ms;
	}

	public void run() {
		while (true) {
			my.stableTest();
		}
	}
}
