package demo;

import java.awt.*;

import javax.swing.*;

public class SyncStack extends MyStack {

	public SyncStack() {
		super("SyncStack");
		setBackground(Color.orange);

	}

	public synchronized void push(char c) {
		boolean full = !(idx > 0);
		if (full) {
			status.setBackground(Color.yellow);
			status.setText("Stack full");
			return;
		}

		assert (idx > 0);
		data[idx] = c;
		stackContent[idx].setText("" + c);
		idx--;
		setPointer(idx);
	}

	public synchronized char pop() {
		char c = 0;
		boolean empty = !(idx < SIZE - 2);
		if (empty) {
			status.setBackground(Color.pink);
			status.setText("stack empty");
			return c;
		}
		
		assert (idx < SIZE - 2);
		idx++;
		setPointer(idx);
		stackContent[idx].setText("");
		c = data[idx];
		data[idx] = '\u0000';
		return c;
	}

	public synchronized boolean stableTest() {
		boolean stable = true;
		if (data[idx] == '\u0000') { // OK
			stable = true;
		} else {
			message[idx].setBackground(Color.RED);
			stable = false;
		}
		return stable;
	}

}